/*
 * dfib.c: Compute floating-point approximations to Fibonacci numbers
 *	using an iterative algorithm.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Copyright (c) 2009 Paul E. McKenney, IBM Corporation.
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double fib(int x)
{
	double phi = (1. + sqrt(5.)) / 2.;

	return floor(pow(phi, (double)x) / sqrt(5.) + 0.5);
}

double garbage;

int main(int argc, char *argv[])
{
	int i;
	int x;

	if (argc != 2) {
		fprintf(stderr, "%s i\n", argv[0]);
		exit(-1);
	}
	x = atoi(argv[1]);

	printf("fib(%d) = %g\n", x, fib(x));
	for (i = 0; i < x; i++)
		garbage += fib(1475);
	return 0;
}
